//  - CDllMethodWrapper -      
//     ( ,   )  dll  1
//
//    aka artbear
//
//	     inline. ..    
//	    !!
//
/*
	 
	1.     -
		typedef int(CBLModule::*PF_FF)(char const * )const;
	2.    
		CDllMethodWrapper<PF_FF> wrapperFindFunc;
	
	3.  
		HINSTANCE hBl=GetModuleHandle("blang.dll");

		wrapperFindFunc.DoWrap(hBl,"?FindFunc@CBLModule@@QBEHPBD@Z", (PF_FF)WrapFindFunc);
		1  -      1
		2 -   
		3 -    ,    
		 4  -  true, ,   
		  false  , ,  ,  

	4.     

	int  CWrapModule::WrapFindFunc(char const * fName)const
	{
		int ret = 0;

		//    
		//wrapperFindFunc.RestoreOrigAddress(); //  .
		CDllMethodWrapper_StackObject<PF_FF> wrapper(wrapperFindFunc);


		//   
		//   
		//ret = (((CBLModule*)this)->*wrapperFindFunc.GetOrigMethod())(fName);
		ret = (((CBLModule*)this)->*wrapper.GetOrigMethod())(fName);

		//   

		//   
		//wrapperFindFunc.RestoreWrapAddress(); //       

		return ret; //      !!
	}
*/
// TODO:
//  .  , ,        
/*
	kms:   :
	*    -    1
	*   GetOrigMethod()     -     IsWrapped;
	*   GetOrigMethod()    -    1
*/

extern CMapPtrToPtr DllMethodWrapperMap;


template <class TFunctionType>
class CDllMethodWrapper
{

	private:
		//    NULL,     DoWrap
		PULARGE_INTEGER adr;

		TFunctionType jmp;
		ULARGE_INTEGER orig;
		ULARGE_INTEGER wrap;

		union PtrC{
			void *pV;
			TFunctionType pMethod;
		};

		//     "RestoreOrigAddress"  "RestoreWrapAddress"
		BOOL m_bIsActive;
	public:
		CDllMethodWrapper() : adr(NULL), m_bIsActive(FALSE)
		{
		};

		~CDllMethodWrapper()
		{
			if (adr)
			{
				//   
				void *ptr;
				if (DllMethodWrapperMap.Lookup(adr, ptr))
					DllMethodWrapperMap.RemoveKey(adr);
			}
		}

		void RestoreOrigAddress(void)
		{
			if (adr)
			{
				(*adr).QuadPart = orig.QuadPart;
				m_bIsActive = TRUE;
			}

		}
		void RestoreWrapAddress(void)
		{
			if (adr)
			{
				(*adr).QuadPart = wrap.QuadPart;
				m_bIsActive = FALSE;
			}
		}

		TFunctionType GetOrigMethod(void)
		{
			//    
			register PtrC conv;

			conv.pV = adr;
			if (!conv.pV)
				RuntimeError("GetOrigMethod failed!");

			return conv.pMethod;
		}

		// FALSE:   ; TRUE:  
		BOOL IsWrapped(void)
		{
			return (adr != NULL);
		}

		// FALSE:        
		// TRUE:  ,    
		//      
		BOOL IsActive(void)
		{
			return m_bIsActive;
		}

		void DoWrap(HINSTANCE hDllInstance, LPCSTR strMethodNameInDll, 
			TFunctionType pWrapperFunction)
		{
			
		/*		//?FindFunc@CBLModule@@QBEHPBD@Z
		adr1=(BYTE*)GetProcAddress(hBl,"?FindFunc@CBLModule@@QBEHPBD@Z");
		jmpWrapFindFunc=(PF_FF)WrapFindFunc;
		adrWrapFindFunc = adr1;
		for(i = 0; i<6;i++) origWrapFindFunc[i] = *adr1++;
		adr1 = adrWrapFindFunc;
		*adr1++=0xFF;
		*adr1++=0x25;
		*(DWORD*)adr1=(DWORD)&jmpWrapFindFunc;
		adr1 = adrWrapFindFunc;
		for(i = 0; i<6;i++) wrapWrapFindFunc[i] = *adr1++;
			*/
			//			void* adr1;
			if (!adr)
			{
				DWORD old;
				
				adr = (PULARGE_INTEGER)GetProcAddress(hDllInstance, strMethodNameInDll);
				if (adr)
				{
					//  
					void *ptr;
					if (DllMethodWrapperMap.Lookup(adr, ptr))
					{
						adr = NULL;
						RuntimeError("DoWrap: %s already wrapped", strMethodNameInDll);
					}

					//  
					ptr = this;
					DllMethodWrapperMap.SetAt(adr, ptr);

					VirtualProtect(adr, 8, PAGE_EXECUTE_READWRITE, &old);
					
					jmp = (TFunctionType)pWrapperFunction;
					
					//   
					orig.QuadPart = (*adr).QuadPart;
					
					//   -   "jmp far "
					wrap.LowPart = 0x000025FF | ((DWORD)&jmp << 16);
					wrap.HighPart = (orig.HighPart & 0xFFFF0000) | ((DWORD)&jmp >> 16);
					
					//  
					(*adr).QuadPart = wrap.QuadPart;
				}
					else
						RuntimeError("DoWrap failed: %s", strMethodNameInDll);
			}
		};

};


//       
template <class TFunctionType>
class CDllMethodWrapper_StackObject
{

	private:
		CDllMethodWrapper<TFunctionType>& m_DllMethodWrapper;
	
	public:
		CDllMethodWrapper_StackObject(CDllMethodWrapper<TFunctionType>& aDllMethodWrapper ) :
			m_DllMethodWrapper(aDllMethodWrapper)
		{
			m_DllMethodWrapper.RestoreOrigAddress();
		};

		~CDllMethodWrapper_StackObject()
		{
			m_DllMethodWrapper.RestoreWrapAddress();
		};

		TFunctionType GetOrigMethod(void)
		{
			return m_DllMethodWrapper.GetOrigMethod();
		}
		
};
